/*************************************************
 n64 rom dump script
*************************************************/

dofile("mapper/fram.nut");

function cpu_dump(d, rom_size, banksize)
{
	for(local i = 0; i < rom_size; i += 0x10000){
		cpu_read(d, 0, 0x10000);
	}
}

function cpu_erase(d, rom_size, flash_chip_type)
{
	//not need here
}
function cpu_flash(d, rom_size, banksize)
{
	//not need here
}
function save_dump(d, save_size, save_type)
{
	if(save_type==0)//SRAM
	{
		for(local i = 0; i < save_size; i += 0x400){
			cpu_read(d, 0x8000000|i, 0x400);
		}
	}
	else if(save_type==1)//EEP
	{
		for(local i = 0; i < save_size; i += 0x200){
			eep_read(d, i/0x200, i/0x200);
		}
	}
	else{//save_type==2 FRAM
		fram_cmd(d,0xF0000000);
		for(local i = 0; i < save_size; i += 0x400){
			cpu_read(d, 0x8000000|i, 0x400);
		}
	}	
}
function save_erase(d, save_size, save_type)
{
	//not need here
}



function save_write(d, save_size, save_type)
{
	if(save_type==0)//SRAM
	{
		for(local i = 0; i < save_size; i += 0x200){
			cpu_write(d, 0x8000000|i, 0x200);
		}
	}
	else if(save_type==1)//EEP
	{
		for(local i = 0; i < save_size; i += 0x200){
			eep_write(d, i, i/0x200);
		}
	}
	else{//save_type==2 FRAM
		erase_fram(d);
		for(local bank=0; bank<8; bank++)
		{
		for(local offset=0; offset<128; offset++)
		{
			fram_cmd(d,0xB4000000);
			
			//for(local j=0; j<128; j=j+2 )
			//{
			//	cmd_write(d,0x8000000+j,0x7788);
			//}
			cpu_write(d, 0x8000000, 0x80);
			fram_cmd(d,(0xA5000000 | (((bank * 128) + offset) & 0xFFFF)));
			fram_cmd(d,0xD2000000);
		}
		}		
	}	
}
